'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var CodeMirror = _interopDefault(require('codemirror'));
var React = require('react');

(function (Mode) {
    Mode["JavaScript"] = "javascript";
    Mode["Markdown"] = "markdown";
})(exports.CodeEditorMode || (exports.CodeEditorMode = {}));
var CodeEditor = function (_a) {
    var defaultValue = _a.defaultValue, mode = _a.mode, onChange = _a.onChange, _b = _a.lineNumbers, lineNumbers = _b === void 0 ? false : _b;
    var textAreaEl = React.useRef(null);
    React.useEffect(function () {
        var codeMirror = CodeMirror.fromTextArea(textAreaEl.current, {
            lineNumbers: lineNumbers,
            mode: mode
        });
        codeMirror.on("change", function (obj) {
            onChange(obj.getValue());
        });
    }, []);
    return (React.createElement("textarea", { "data-testid": "textarea", ref: textAreaEl, defaultValue: defaultValue }));
};

exports.CodeEditor = CodeEditor;
